// TI File $Revision: /main/2 $
// Checkin $Date: April 28, 2005   14:57:07 $
//###########################################################################
//
// FILE:  DSP281x_XIntrupt.h
//
// TITLE: DSP281x Device External Interrupt Register Definitions.
//
//###########################################################################
// $TI Release: DSP281x C/C++ Header Files V1.20 $
// $Release Date: July 27, 2009 $
//###########################################################################

#ifndef USER_DECVAR_H
#define USER_DECVAR_H


#ifdef __cplusplus
extern "C" {
#endif

//汾------------------------------
#define SOFTWARE_VERSION1    0x0203
#define SOFTWARE_VERSION2    1
#define SOFTWARE_VERSION3    0
#define SOFTWARE_VERSION4    15040

#define LOW     0
#define HIGH    1
#define TRUE    1
#define FALSE   0
#define Q15_MAX 32767
#define PI      25735   //25723  //  Q13,    3.14159
#define GENHAO2_1       23170         //Q15 2֮1
#define POWER_TORQUE_COE 9550

#define VVVF_DEF    0      

extern int16 CanSend1;
extern int16 CanSend2;
extern int16 CanSend3;
extern int16 CanSend4;

extern int16 CanInitFlag;

//ͨЭID-------------------------------------------------
#define	SHAKE_FIR_REC		0x11111200
#define SHAKE_FIR_ACK		0x11111201

#define SHAKE_SEC_SEND		0x11111300
#define SHAKE_SEC_REC		0x11111301
#define SHAKE_SEC_ACK		0x11111302

#define DATA_REC_SEND		0x11111400
#define DATA_REC_ACK		0x11111500

#define FILE_SEND_FINISH	0x11111600
#define FILE_SEND_ACK		0x11111601

#define SEND_NULL			0xFFFFFFFF

#define BOOT_SHAKE_SUCCESS	0x03

//---------------------------------------------------------
struct BOOTSTATUS{
	int16   FrameId;
	int16	LineDataLen;
	int16   LineId;
	int16   HexRow;
	int16	WorkStatus;
    int16 	Reboot;
    Uint32 	SendNum;
    unsigned char Buffer[100];
};

extern struct BOOTSTATUS BootStatus;

struct  CANMBOX_USER_REGS
{
    Uint16     MboxRxFlg; 
    Uint16     MboxNum;
    Uint16     MboxDLC;    
    Uint32     MboxID;
    int16      MboxWord1;
    int16      MboxWord2;
    int16      MboxWord3;
    int16      MboxWord4;

};

extern struct CANMBOX_USER_REGS CanMboxUserRegsT;
extern struct CANMBOX_USER_REGS CanMboxUserRegsR;
extern struct CANMBOX_USER_REGS CanMboxUserRegsR2;

extern void ECanMboxSend(struct  CANMBOX_USER_REGS *pRegs);
extern struct CANMBOX_USER_REGS ECanMboxRead(void);
extern void CanMaster(void);
extern void RunLedSet(void);
extern void RunLedClr(void);
extern void RunLedControl(void);

#ifdef __cplusplus
}
#endif /* extern "C" */

#endif  // end of DSP281x_XINTF_H definition



//===========================================================================
// No more.
//===========================================================================



